*** empty log message ***
authorJim Meyering <jim@meyering.net>
Tue, 14 Oct 2003 09:04:36 +0000 (09:04 +0000)
committerJim Meyering <jim@meyering.net>
Tue, 14 Oct 2003 09:04:36 +0000 (09:04 +0000)
tests/chgrp/posix-H [new file with mode: 0755]

diff --git a/tests/chgrp/posix-H b/tests/chgrp/posix-H
new file mode 100755 (executable)
index 0000000..1652e59
--- /dev/null
@@ -0,0 +1,72 @@
+#!/bin/sh
+# Test POSIX-mandated -H option.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  chgrp --version
+fi
+
+. $srcdir/../group-names
+set _ $groups; shift
+g1=$1
+g2=$2
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+mkdir 1 2 3 || framework_failure=1
+touch 1/1F 2/2F 3/3F || framework_failure=1
+ln -s 1 1s || framework_failure=1
+ln -s ../3 2/2s || framework_failure=1
+chgrp -R $g1 1 2 3 || framework_failure=1
+
+if test $framework_failure = 1; then
+  echo "$0: failure in testing framework" 1>&2
+  (exit 1); exit 1
+fi
+
+fail=0
+
+chgrp -HR $g2 1s 2 || fail=1
+
+# These must have group $g2.
+# =========================
+changed='
+1
+1/1F
+2
+2/2s
+2/2F
+'
+for i in $changed; do
+  # Filter out symlinks (entries that end in `s'), since it's not
+  # possible to change their group/owner information on some systems.
+  case $i in *s) continue;; esac
+  set _ `ls -dg $i`; shift
+  group=$3
+  test $group = $g2 || fail=1
+done
+
+# These must have group $g1.
+# =========================
+not_changed='
+3
+3/3F
+1s
+'
+for i in $not_changed; do
+  # Filter out symlinks (entries that end in `s'), since it's not
+  # possible to change their group/owner information on some systems.
+  case $i in *s) continue;; esac
+  set _ `ls -dg $i`; shift
+  group=$3
+  test $group = $g1 || fail=1
+done
+
+(exit $fail); exit $fail